﻿local t = nil
local elapsed = 0
local update_interval = 1
local filters = nil
local gmotd_now = nil
local gmotd_last_loaded = nil
local smotd_now = nil
local smotd_last_loaded = nil

function motdstripper_onload()
	this:RegisterEvent("ADDON_LOADED")
	this:RegisterEvent("GUILD_MOTD")
	this:RegisterEvent("CHAT_MSG_SYSTEM")
end

local function msg(msg)
	DEFAULT_CHAT_FRAME:AddMessage(msg)
end

local function chatfilter()
	if elapsed <= update_interval then
		return true
	end
end

function motdstripper_onevent(self, event, ...)
	if event == "ADDON_LOADED" and ... == "MOTDstripper" then
		if gmotd_last_saved then
			gmotd_last_loaded = gmotd_last_saved
		end
		if smotd_last_saved then
			smotd_last_loaded = smotd_last_saved
		end
		this:UnregisterEvent("ADDON_LOADED")
	end
	if event == "GUILD_MOTD" then
		gmotd_now = ...
		gmotd_last_saved = gmotd_now
		if gmotd_last_loaded == gmotd_now then
			GUILD_MOTD_TEMPLATE = string.gsub(GUILD_MOTD_TEMPLATE, ".*", "")
		end
		this:UnregisterEvent("GUILD_MOTD")
	end
	if event == "CHAT_MSG_SYSTEM" then
		if t then
			elapsed = time() - t
		end
		if elapsed <= update_interval then
			if smotd_now then
				smotd_now = smotd_now .. " " .. ...
			else
				smotd_now = ...
			end
			smotd_last_saved = smotd_now
			if smotd_last_loaded and string.match(smotd_last_loaded, smotd_now) then
				ChatFrame_AddMessageEventFilter("CHAT_MSG_SYSTEM", chatfilter)
			end
		else
			this:UnregisterEvent("CHAT_MSG_SYSTEM")
			filters = ChatFrame_GetMessageEventFilters("CHAT_MSG_SYSTEM")
			if filters then
				for i=1, #filters do
					ChatFrame_RemoveMessageEventFilter("CHAT_MSG_SYSTEM", chatfilter)
				end
			end
		end
		t = time()
	end
end